% FILE  e105.m  begins.  
% USES  deq105.m
% Solves y" + a*y' + b*y = 0; y(0) = 1; y'(0) = 0.0
% Want  y(1.0) = ?
% Write as: y" = -a*y' - b*y, 
% Substitute y2 = y',  y1 = y to obtain
%           y1' = y2
%           y2' = -a*y2 - b*y1
% 
clear;
global a;
global b;
a =- 0.05; b= 0.15;
fval = 1.0;
dfval = 0.0;
[t,y] = ode23('deq105', [0.0 1.0], [fval dfval]);
clf;
axes('FontSize',[15],'FontWeight','bold');  hold on;
plt1=plot(t,y(:,1));
txt=['Solution: y(1.0) = ' num2str(y(size(y,1),1)) ];
title(txt,'FontSize',[15]);
xlabel('E105','FontSize',[15]);
set(plt1,'LineWidth', 2.5);  % Line width is changed
grid;
hold off;
A=[t,y(:,1),y(:,2)]
% FILE  e105.m  ends.
