%FILE: roundoff.m
% Study loss of significant digits,
% due to roundoff errors / floating point arithmetic
clear
close all
path(path,' ../util')
x1=10^(-25); x2=10^(-10); x=x1+(x2-x1)*(0:0.0001:1);
for p=1.35:0.1:1.8
y1=sqrt(1+x.^p)-1; y2=(x.^p)./ (1+ sqrt(1+x.^p));
figure
plot(x,y1,'r-')
hold on
plot(x,y2,'b-')
xlabel(['p = ' num2str(p)])
widemarg(gcf)
end
%FILE: roundoff.m
