% FILE  adrlstTst.m  begins.
% Last modified 2018-09-10
% Creates an artificial "database" of persons
% as a MATLAB struct. Then orders it according
% to field content
clear all; close all
first0='aino';            flst=perms(first0);
last0='maki';             llst=perms(last0);
id0='5678';               idlst=perms(id0);
street0='vesilinn 5';  slst=perms(street0(1:4));
city0='turku';         clst=perms(city0(1:4));
% Random string of 5 letters: randsample(char(65:90),5)
n=factorial(length(first0)); % length of flst
prs=struct('First',first0,'Last',last0,...
   'Id',id0,'Street',street0,...
   'City',city0,'Data',fix(100*rand(1,3)))
txt='First    Last     Id      Street     City ';
txt=[txt '    Data(1:3)   Aver/data'];   
disp(txt);
lin='------------------------------';
lin=[lin lin];
disp(lin);
s1=0.0;
for j=1:n
   prs(j)=struct('First',flst(j,:),'Last',llst(j,:),...
      'Id',idlst(j,:),'Street',slst(j,:),...
       'City',clst(j,:),'Data',fix(100*rand(1,3)));
   txt=[prs(j).First];
   txt=[txt blanks(5) prs(j).Last];
   txt=[txt blanks(5) prs(j).Id];
   txt=[txt blanks(5) prs(j).Street];
   txt=[txt blanks(5) prs(j).City];
   txt=[txt blanks(5) mat2str(prs(j).Data)];
   s1=s1+prs(j).Data(1);
   fprintf(['%s  %d\n' lin '\n'],...
                txt,fix(sum(prs(j).Data)/3));
end
disp(['Sum of data(1) = ' num2str(s1)])
A=prs;
% print the fieldnames of A
for fn=fieldnames(A)'
disp(fn)
end
disp('Sort A by last name:') 
% Found by Googling "sort struct MATLAB"
[tmp ind]=sort({A.Last});
A(ind)
for kk=1:n
    disp(A(ind(kk)).Last)
end
disp('Sort A by street address:')
[tmp ind2]=sort({A.Street});

for kk=1:n
    disp(A(ind2(kk)).Street)
end
% 
disp('Sort A by sum(Data)')
v=rand(n,3); % Data is copied in v :
for jj=1:n
v(jj,:)=A(jj).Data;
end
[vsorted, idxsort]=sort(sum(v,2)); 
% sum(v,2) gives row sums of v
for jj=1:n
    kk=idxsort(jj);
    txt=[ prs(kk).Last ' '  prs(kk).First ]; 
    txt=[txt '  ' num2str(sum(prs(kk).Data))];
    fprintf('%s \n',txt);
end
vsum=sum(v,2);
hist(vsum,10)
maxhist=max(histcounts(vsum,10));
%maxhist counts the height of highest bin of hist
mi=min(vsum); mx=max(vsum);
kynnys=max(mi, 0.45*mx);
rajat=fix(kynnys:0.25*(0.9*mx-kynnys):(0.9*mx));
luokat=zeros(1,5);
for jj=1:4
     luokat(jj)= sum((vsum>=rajat(jj)).*(vsum<rajat(jj+1)));
end
luokat(5)=  sum(vsum> rajat(5));
for jj=1:5
  fprintf('%d : %d -  %d kpl  \n', jj, rajat(jj), luokat(jj))    
end
hylatyt=sum(vsum<rajat(1));
hold on
 for jj=1:length(rajat)  % plot vertical segments
 plot([rajat(jj),rajat(jj)], [0, maxhist+1],'r-','LineWidth',2   )
 end
grid 
disp([ num2str( sum(luokat)) ' passed/ ' num2str(length(prs))])
for jj=1:n
    p=ind(jj);
    grade=0;
    for kk=1:5
        if vsum(p)>rajat(kk)
            grade=grade+1;
        end    
    end
    if grade>1
    disp([ A(p).Last ',' A(p).First  '  ' num2str(grade) ])
    end
end        
% FILE  adrlstTst.m  ends.
