% FILE  e217.m  begins.
% Draw Julia set . From Marcus: Matrices and Matlab p. 74
% A vectorized 10 times faster version is in e217vec.m
% The slowness is caused by the nested for loops
% which can be avoided, if vectorization is used
% Try c = -1 and c = -0.1+ 0.8*i
% 2018
  c = input ('enter a complex number c = c1 + i * c2  ');
                tic;
                jul = [];
                for x = -2:.05:2
                        for y = -2:.05:2
                                z = x + i * y;
                                b = z;
                                n = 1;
                                while ((n <= 20) & (abs(b) <= 2))
                                        b = b^2+ c;
                                        n = n + 1;
                                end
                                if n == 21
                                        jul = [jul z];
                                end
                        end
                end
  axis('square')
  tempus=toc;
  txt =[num2str(c)];
  if isempty(jul)==1 
        error('     Your c is not suitable!');
  else 
        plot(jul, '+');
  end
  title(['Julia set of z^2 + c, c = ' txt]),
  xlabel(['E217   , CPUTIME = ' num2str(tempus) ]),pause;
% FILE  e217.m  ends.
