% FILE: how2anonfun.m begin
% How to use anonymous functions
close all
clear

f= @(a)(det(a));

for k=1:3
	a=rand(2*k, 2*k);
        fprintf('%12.7f\n',f(a));
end

g= @(x)(sin(x+f(a)+0.1))


myrt=fzero(g,0)
  x=-abs(myrt):0.01:2*pi;
figure
plot(x,g(x), 'b',[myrt, myrt],[-1 1],'r')
grid on
  title(['Root is :' num2str(myrt)])
  numint=quad(g,0,2*pi);
xlabel(['Numerical integration yields: ' num2str(numint,'%12.4e')])



myf =@(x,y,s)( ((abs(x)+abs(y)).^s )./(1+abs(x).^2 +abs(y).^2) );
myf(2,3,1.2)

xvec=-7:0.1:7;
[xx,yy]=meshgrid(xvec, xvec);
zz= myf(xx,yy,1.2);
size(xx)
size(zz)
figure
surf(xx, yy, zz)

% FILE: how2anonfun.m end
