% FILE  parf04.m  begins.
% This is an improved version of parfit!!
% Note: (a) The use of inline functions  
%           ==> fobj, fmodel can be also defined within this file
%       (b) No global variables needed
clear
close all
fmodel=inline('exp(-lam(1)* x) +lam(2)*exp(-lam(3)*x)','x','lam');
%fmodel=inline('exp(-lam(1)* x) +lam(2)*exp(-lam(3)*x)+5*cos(6*x)','x', 'lam');
%fmodel=inline('exp(-lam(1)* x) +lam(2)*exp(-lam(3)*x)+5*(6*x+1).^2','x','lam');

%fobj=inline('norm(feval(fmodel,x,lam)-y)','lam','fmodel','x','y');
fobj=inline('norm(fmodel(x,lam)-y)','lam','fmodel','x','y');
xdata= 0:0.05:1.1;
lam1=[0.2 1.5 0.7];
y=fmodel(xdata,lam1); % Generate syntetic data 
                      % with parameters lam1
ydata= y.*(0.97+0.15*rand(1,length(xdata)));
                      % Add some "errors"
lam0=[1,1,1];
y0=fobj(lam0,fmodel,xdata,ydata);  % Initial value of object function
[lam fval eflag] = fminsearch(fobj,lam0,[],fmodel,xdata,ydata);
disp([lam fval eflag])
yfinal=fval;                       % Final value of the object function
x=0:0.05:1.5;
yfit=fmodel(x, lam);
clf;
axes('FontSize',[15],'FontWeight','bold'); hold on;
title(['Object function values: start =' num2str(y0,3) ', final = ' ...
       num2str(yfinal,3)])
plt=plot(x,yfit,xdata,ydata,'k.','MarkerSize',30);  grid on;
txt1=' {\bf Fitted curve (solid)}';
text(x(5)+0.05,yfit(5),txt1,'FontWeight','bold','FontSize',[16]);
txt2=' {\bf Data point (dots)}';
text(xdata(8)+0.05,ydata(8),txt2,'FontWeight','bold','FontSize',[16]);
ax=axis; x1=ax(1)+0.1*(ax(2)-ax(1)); y1=ax(3)+0.9*(ax(4)-ax(3));
text(x1,y1, ['lam= ' mat2str(lam,3)],'FontWeight','bold','FontSize',[16]);
ylabel('ydata '); xlabel('xdata (parf04/MME04)')
set(plt,'LineWidth',2.5);
% FILE  parf04.m  ends.
