% FILE tstfminbnd.m begins.
clear
close all
myf=inline('(x-p).^2 +5*p*sin(5*x).^p ','x','p');
xvec=1:0.1:7;
for m=2:5
% [X,Y] = FMINBND(FUN,x1,x2,OPTIONS,P1,P2,...) provides for additional
% arguments, which are passed to the objective function, FUN(X,P1,P2,...).
% (Use OPTIONS = [] as a place holder if no options are set.)

[x fval ] = fminbnd(myf,1 ,8,[],m);  
disp([m  x fval ])
figure(m)
axes('FontSize',[15],'FontWeight','bold');
plot(xvec,myf(xvec,m));
tx=num2str(m);
txt = ['f(x) = (x-' tx ').^2 +5*' tx '*sin(5*x).^' tx ];
ax=axis; x1=ax(1); x2=ax(2); y1=ax(3); y2=ax(4); 
myx=x1+0.1*(x2-x1); myy=y1+0.9*(y2-y1);
text(myx,myy,txt,'FontSize',[20]);
xlabel(['a = ' num2str(x) ', f(a)= ' num2str(fval)], ...
            'FontSize',[18] );
grid on
hold on
plot(x,fval,'k.','MarkerSize',30)
pause(2)
end
% FILE  tstfminbnd.m ends.
