% FILE  e304b.m  begins.
% 2005-09-27
% Study polynomial fit
% Read data from file
path(path,'../luku2')   % putmat and getmat are needed
n =3;  %degree of polynomial
x = 20*sort(abs(rand(1,20))); y = x.*log(x) + 5*sin(x);
fnamea=putmat(x,'a.dat',' %12.4f');
fnameb=putmat(y,'b.dat',' %12.4f');
clear x
clear y
x2=getmat(fnamea); % read data
y2=getmat(fnameb);
x=x2;
y=y2;
a = polyfit(x,y,n);
xmi = min(x); xma= max(x); dx =0.01*(xma-xmi);
xi =xmi:dx:xma; yi = polyval(a,xi);
clf;                % clear the current figure
axes('FontSize',[15],'FontWeight','bold');  hold on;
txt =['Polynomial fit of degree '  num2str(n) ' (data with errorbars)'];
plt1=plot(x,y,'k.',xi,yi,'MarkerSize',30); 
title(txt,'FontSize',[15]);
xlabel('E304b','FontSize',[15]);
e=0.3*std(y)*ones(size(x));
errorbar(x,y,e);
set(plt1,'LineWidth', 2.5);       % Line width is changed
grid on
hold off;
% FILE  e304b.m  ends.
