% FILE  e306b.m  begins.
% 2018: Extrapolation to census data
% based on pth degree polynomial fitting, p=1:8
close all; clear
yr2= 1900:10:1970;
yr=0:10:70;
pop =[ 70, 92 , 106, 123, 131, 150, 180, 200];
coef= polyfit(yr,pop,7);
yri = 00:5: 90;
close all
for n=1:8
%clf;
figure
coef= polyfit(yr,pop,n);
popi= polyval(coef,yri);
axes('FontSize',[15],'FontWeight','bold');  hold on;
plt1=plot(yr,pop,'k.', yri,popi,'MarkerSize',[30]);
c = polyfit(yr, pop,1);
poplin =polyval(c,yri);
pop90=polyval(coef,90);
est = polyval(c,90);
txt2= ['Linear extrapolation yields ' num2str(est,'%6.2f')];
txt =['Degree ' num2str(n) ' polyn.prediction v. 1990: ' ...
      num2str(pop90,'%6.2f')];
plt2=plot(yr, pop,'wo',yri, poplin, yri, popi);
title(txt,'FontSize',[15]);
text(10,1500,txt2,'FontSize',[15],'FontWeight','bold');
xlabel('year  (E306b)','FontSize',[15]);
ylabel('USA population (milj.)','FontSize',[15]);
grid;
set(plt1,'LineWidth', 2.5);       % Line width is changed
set(plt2,'LineWidth', 2.5);       % Line width is changed
hold off;

pause(1.5)

end
% FILE  e306b.m  ends.
