% FILE  e311.m  begins.
% Piecewise cubic Hermite interpolation, pchip,
% produces monotone interpolant to monotone data
% whereas spline does not
clear; close all;
axes('FontSize',[15],'FontWeight','bold');  
hold on; 
x=-1:0.05:1;
y=0.1*x.*(x<=0)+ 0.1*((x+10).*(x>0));
xi=-1:0.01:1;
yi=spline(x,y,xi);
plot(x,y,'ko',xi,yi,'LineWidth', 2);
title('Monotone data, nonmonotone spline interpolant',...
    'FontSize',[15])
grid
figure
yi=pchip(x,y,xi);
plot(x,y,'ko',xi,yi);
title('Monotone data, PCHIP interpolant','FontSize',[15])
grid
figure
axes('FontSize',[15],'FontWeight','bold');  hold on;
x = -3:3;
y = [-1 -1 -1 0 1 1 1];
y=y+0.05*x;
t = -3:.01:3;
plot(x,y,'o',t,[pchip(x,y,t); spline(x,y,t)],...
    'MarkerSize',[12],'LineWidth', 2.5);
legend('data','pchip','spline')
grid on
% FILE  e311.m  ends.

