% FILE  mydblquad.m begins.
% This program shows how to carry out
% double integration over the plane
% region bounded by the curves y=g1(x)
% and y=g2(x,j) and two vertical lines
function w= mydblquad
clear
myf2=inline('sqrt(  max(1-x.^2-y.^2,0))  ','x','y');
res2=dblquad(myf2, 0.1, 0.5, 0.0, 0.2);

for kk=3:5
res=dblquad(@myf, 0.0, 1, 0.0, 1,[],[],kk);
fprintf('kk= %d, result = %12.6f \n',kk,res);
end

function w=myf(x,y,j)
tst=  (y>g2(x,j));
tst=  (y>g2(x,j) & y<g1(x));
w=tst.*sqrt(  max(1-x.^2-y.^2,0)).^j;
w=tst.*ones(size(x));

function y=g1(x)
  y=x.^1;
function y=g2(x,j)
  y=x.^j;
% FILE mydblquad.m ends.
