% FILE myinterp2.m begins.
% 2004-10-01 morning temperatures in the cities
% Tku Hki Pori Jkyla Vaasa Mikkeli
close all; clear; 
temp=[-0.8  4   -0.2    -1.5  6.6  -1.8];
% city coordinates
x=[0  1.5  0 1.5 0.5 3.0];
y=[0  0  1.4  3 3.5 1.00];
xvec=[-0.5: 0.1: 3];
yvec=-0.5:0.1:3.6;
[xi,yi]=meshgrid(xvec, yvec);
zi=griddata(x,y,temp,xi,yi,'cubic');
mesh(xi,yi,zi)
tre=interp2(xi,yi,zi,0.5,1.5)
fprintf('Tampere measured 2.4, interpolated = %5.2f\n',tre)
hold on
plot3(x,y,temp,'k*', 0.5 , 1.5 , tre, 'k.','MarkerSize',20)
pause(3)

% Compare graphically some 2D-interpolation
% methods: nearest, linear spline
clear; figure
a=2*rand; b=2*rand+2;
myf=inline(' x.^2+(y.^2).*sin(v*x.*y+cos(v*x.*y))','x','y','u','v');
n=5;
x=sort(5*rand(1,n));
y=sort(5*rand(1,n));
[xx,yy]=meshgrid(x,y);
a=4*rand; b=3*rand;
zz=myf(xx,yy,a,b);
xi=0:0.1:4;
yi=(0:0.1:4)';
zi=interp2(xx,yy,zz,xi,yi,'nearest');
zi2=interp2(xx,yy,zz,xi,yi,'linear');
zi3=interp2(xx,yy,zz,xi,yi,'spline');
    subplot(1,2,1)
    surf(xi,yi,zi)
    subplot(1,2,2)
    contour(xi,yi,zi)
   figure
    subplot(1,2,1)
    surf(xi,yi,zi2)
    subplot(1,2,2)
    contour(xi,yi,zi2)
    figure
    subplot(1,2,1)
    surf(xi,yi,zi3)
    subplot(1,2,2)
    contour(xi,yi,zi3)
% FILE myinterp2.m ends.
