% FILE mynumdertst.m begins.
% Find optimal h for numerical differentiation:
% Method I:  Using  f(x0+h)-f(x0))/(h)
% Method II: Using  (f(x0+h)-f(x0-h))/(2*h)
close all
path(path,' ../util')
startup
x0=0.5;
n=3:0.1:16;
z=cos(x0)- (sin(x0+10.^(-n))-sin(x0))./(10.^(-n));
title(['Error in numdif with h= 10^{-n} '])
semilogy(n, (abs(z)+10^(-25)),'b-')
ax=axis;
goody=0.5*(ax(3)+ax(4));
[miner,minind]=min(abs(z));
%text(3,0.5*goody,['min.error for h= 10^{' num2str(-n(minind),'%8.2f' ) '}'])
title(['Min.error in numdif with h= 10^{' num2str(-n(minind),'%8.2f' ) '}'])
xlabel('Using  (f(x0+h)-f(x0))/(h),  h=10^{-n}')
grid on
figure
z2=cos(x0)- (sin(x0+10.^(-n))-sin(x0-10.^(-n)))./(2*10.^(-n));
title(['Error in numdif with h= 10^{-n} '])
semilogy(n, (abs(z2)+10^(-25)),'r-')
ax=axis;
goody=0.5*(ax(3)+ax(4));
[miner,minind]=min(abs(z2));
%text(3,0.5*goody,['min.error for h= 10^{' num2str(-n(minind),'%8.2f' ) '}'])
title(['Min.error in numdif with h= 10^{' num2str(-n(minind),'%8.2f' ) '}'])
xlabel('Using  (f(x0+h)-f(x0-h))/(2*h), h=10^{-n}')
grid on
figure
z2=cos(x0)- (sin(x0+10.^(-n))-sin(x0-10.^(-n)))./(2*10.^(-n));
title(['Error in numdif with h= 10^{-n} '])
semilogy(n, (abs(z)+10^(-25)),'b-', n, (abs(z2)+10^(-25)),'r-')
ax=axis;
goody=0.5*(ax(3)+ax(4));
[miner,minind]=min(abs(z2));
xlabel('Blue: method I, red: method II')
grid on
% FILE  mynumdertst.m ends.
