% FILE mysplinecoef.m begins.
% The spline command produces piecewise
% polynomial approximation of degree 3.
% These pieces correspond to successive
% intervals on the real axis. This program
% demonstrates how to access these piecewise coefficients
clear; close all;
path(path,'../util') %startup
x=5*sort(rand(1,20));   % OR: x=0:0.2:5;
y= sin(x)+2*cos(2*x);
pp= spline(x,y);
plot(x,y,'y-',x,y,'b*','LineWidth',4);
hold on;
for kk=1:(length(x)-1)  % plot piecewise
  mylen=(x(kk+1) - x(kk));
  xi=0:0.02*mylen:mylen;
  a=pp.coefs(kk,:)
  yi=polyval(a,xi);
  plot(xi+x(kk),yi,'k-','LineWidth',2);
  title('mysplinecoef')
  pause(1)
end
% FILE mysplinecoef.m ends.
