% FILE mysplinerror.m begins.
% Compare spline and polynomial
% approximation of data
% How to get the piecewise polynomial coefficients 
% from spline
function w= www
close all; clear;
a=2+1*rand(1,2);
x=0:0.2:1; y=myf2(x,a);
xi=0:0.05:1;
yi=myf2(xi,a);
pp=spline(x,y);
coef=pp.coefs;
xi1=0:0.05:0.2;
yi1=polyval(coef(1,:),xi1);
xi2=0.2:0.05:0.4;
yi2=polyval(coef(2,:),xi2);
xi3=0.4:0.05:0.6;
yi3=polyval(coef(3,:),xi3);
xi4=0.6:0.05:0.8;
yi4=polyval(coef(4,:),xi4);
xi5=0.8:0.05:1;
yi5=polyval(coef(5,:),xi5);
figure
subplot(1,2,1)
plot(x,y,'k*', xi,yi,'k-')
title('Spline')
grid 
subplot(1,2,2)
plot(x,y,'k*', xi,ppval(pp,xi),'k-')
title('ppval')
grid 
figure
plot(xi,yi-ppval(pp,xi),'b-')
title('true values---spline')
grid 
myaccuracytst
%%%%%%%%%%%%%%%%%%%%%%%
function y= myf2(x,a)
y=sin(a(1)*x)+a(2)*cos(2*a(2)*x);

function myaccuracytst
% Error in interp1 approximation using: spline, pchip
clear; 
x=0:0.1:2; y= sin(x);
xi=0:0.05:2; 
figure  %interp1
yi=interp1(x,y,xi);
subplot(2,1,1)
plot(x,y,'*', xi,yi,'k-')
subplot(2,1,2)
plot(xi,sin(xi)-yi,'k-')
title('Error in interp1')
figure  % spline
yi=interp1(x,y,xi, 'spline');
subplot(2,1,1)
plot(x,y,'*', xi,yi,'k-')
subplot(2,1,2)
plot(xi,sin(xi)-yi,'k-')
title('Error in spline')
figure % pchip
yi=interp1(x,y,xi,'pchip');
subplot(2,1,1)
plot(x,y,'*', xi,yi,'k-')
subplot(2,1,2)
plot(xi,sin(xi)-yi,'k-')
title('Error in pchip')
% FILE  mysplinerror.m ends.
