% FILE  e510.m  begins.
% Fixed point iteration for a linear system.
%
%  8x + y - 2z - 8   = 0
%  x + 18y - 6z + 10 = 0
%  2x + y + 16z + 2  = 0
%
%  or   F u = G;  F =[8 1 -2; 1 18 -6; 2 1 16]
%                 G = [8 -10 -2]'
%
%  is equivalent to:
%  x = .2x -.1y +.2z + .8
%  y = -.05x + .1y +.3z -.5
%  z = -.1x -.05y +.2z - .1
x0 =0.55; y0 = 0.1; z0 =1;
%v =[x0 y0 z0]'; %  
v=rand(3,1);
a =[.2 -.1 .2; -.05 .1 .3; -.1 -.05 .2]; b = [.8 -.5 -.1]';
data =[];
for k =1:50
    vold =v;
    v =a*v+b;
    data = [data; v'];
end;
disp('Fixed point iteration   (E510) ');
disp(['   x                y               z ']);
fprintf(1, ' %12.8f     %12.8f    %12.8f  \n',data(1:10,1:3)');
%disp(['|x(30) -x(31)| = ' num2str(abs(xold-x))]);
F =[8 1 -2; 1 18 -6; 2 1 16];
G = [8 -10 -2]';
u = F\G;
disp(['MATLAB solution =' mat2str(u',5) ])
disp(['Error = ' num2str(norm(data(end,:)' -u) )])
% FILE  e510.m  ends.
